/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/* 
 * Authors : 
 *  Chenthill Palnisamy <pchenthill@novell.com>
 *
 * Copyright 2003, Novell, Inc.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of version 2 of the GNU Lesser General Public 
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef E_GW_TIMEZONE_H
#define E_GW_TIMEZONE_H

#include <libsoup/soup-soap-message.h>

G_BEGIN_DECLS

#define E_TYPE_GW_TIMEZONE		(e_gw_timezone_get_type ())
#define E_GW_TIMEZONE(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), E_TYPE_GW_TIMEZONE, EGwTimezone))
#define E_GW_TIMEZONE_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), E_TYPE_GW_TIMEZONE, EGwTimezoneClass))
#define E_IS_GW_TIMEZONE(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), E_TYPE_GW_TIMEZONE))
#define E_IS_GW_TIMEZONE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), E_TYPE_GW_TIMEZONE))

typedef struct _EGwTimezone EGwTimezone;
typedef struct _EGwTimezoneClass EGwTimezoneClass;
typedef struct _EGwTimezonePrivate EGwTimezonePrivate;
typedef struct _EGwTzComp EGwTzComp;

struct _EGwTimezone {
	GObject parent;
	EGwTimezonePrivate *priv;
};

struct _EGwTimezoneClass {
	GObjectClass parent_class;
};

GType e_gw_timezone_get_type (void);
EGwTimezone *e_gw_timezone_new (void);
void e_gw_timezone_set_description (EGwTimezone *timezone, const char *desc);
void e_gw_timezone_set_id (EGwTimezone *timezone, const char *id);
void e_gw_timezone_set_component (EGwTimezone *timezone, EGwTzComp *tzcomp, gboolean daylight);

const char *e_gw_timezone_get_description (EGwTimezone *timezone);
const char *e_gw_timezone_get_id (EGwTimezone *timezone);
const EGwTzComp *e_gw_timezone_get_component (EGwTimezone *timezone, gboolean daylight);

EGwTzComp *e_gw_tzcomp_new (void);
void e_gw_tzcomp_set_name (EGwTzComp *comp, const char *name);
void e_gw_tzcomp_set_month (EGwTzComp *comp, gshort month);
void e_gw_tzcomp_set_day (EGwTzComp *comp, gshort day);
void e_gw_tzcomp_set_dayofweek (EGwTzComp *comp, gshort dayofweek);
void e_gw_tzcomp_set_hour (EGwTzComp *comp, gshort hour);
void e_gw_tzcomp_set_minute (EGwTzComp *comp, gshort minute);
void e_gw_tzcomp_set_offset (EGwTzComp *comp, gint offset);
void e_gw_tzcomp_set_occurrence (EGwTzComp *comp, gshort occurrence);

const char *e_gw_tzcomp_get_name (EGwTzComp *comp);
gshort e_gw_tzcomp_get_month (EGwTzComp *comp);
gshort e_gw_tzcomp_get_day (EGwTzComp *comp);
gshort e_gw_tzcomp_get_dayofweek (EGwTzComp *comp);
gshort e_gw_tzcomp_get_hour (EGwTzComp *comp);
gshort e_gw_tzcomp_get_minute (EGwTzComp *comp);
gint e_gw_tzcomp_get_offset (EGwTzComp *comp);
gshort e_gw_tzcomp_get_occurrence (EGwTzComp *comp);

void e_gw_tzcomp_free (EGwTzComp *tzcomp);

void e_gw_timezone_append_to_soap_message (EGwTimezone *timezone, SoupSoapMessage *message);

G_END_DECLS

#endif
